# Copyright (c) 2004-2006 Bethel University. All rights reserved.
# See also gpl.txt
from Products.Silva.silvaxml.xmlimport import theXMLImporter, SilvaBaseHandler, generateUniqueId
from Products.Silva import mangle

ProductNS = 'http://zope.org/Members/aaltepet/ns/silva_stylesheets'

def initializeXMLImportRegistry():
    """Initialize the global importer object.
    """
    importer = theXMLImporter
    importer.registerHandler((ProductNS, 'stylesheet'), StylesheetHandler)
    importer.registerHandler((ProductNS, 'set'), StylesetHandler)

class StylesheetHandler(SilvaBaseHandler):
    def startElementNS(self, name, qname, attrs):
        if name == (ProductNS, 'stylesheet'):
            id = str(attrs[(None, 'id')])
            uid = generateUniqueId(id, self.parent())
            self.parent().manage_addProduct['SilvaStylesheets'].manage_addStylesheet(uid, '')
            obj = getattr(self.parent(), uid)
            #also want to set local_types and depth
            self.setResult(obj)
    def endElementNS(self, name, qname):
        if name == (ProductNS, 'stylesheet'):
            self.setMaintitle()
            self.storeMetadata()

class StylesetHandler(SilvaBaseHandler):
    def startElementNS(self, name, qname, attrs):
        if name == (ProductNS, 'set'):
            self.set_id = attrs[(None,'name')].encode('utf-8')
            self.styleset = {}
        elif name == (ProductNS,'style'):
            self.stylename = attrs[(None,'id')].encode('utf-8')
            self.styleset[self.stylename] = []
        self.setResult(None)
        
    def characters(self, chrs):
        self.styleset[self.stylename] = chrs.split('\n')

    def endElementNS(self, name, qname):
        if name == (ProductNS, 'set'):
            self.parentHandler()._result.save_styles(self.set_id,
                                                     self.styleset)
            self.set_id = None
        elif name == (ProductNS, 'style'):
            self.stylename = None
